﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BaileyFarmerGame
{
    class FarmerUI
    {
        public FarmerUI()
        {
        }

        public void PlayGame()
        {
            bool playAgain = true;
            string response;

            DisplayWelcome();

            do
            {
                Console.Clear();

                Play();
                Console.Write("\nDo you want to play again? ");
                response = Console.ReadLine().ToUpper();
                response = response.Substring(0, 1);
                if (response == "NO" || response != "N")
                {
                    continue;
                }
                playAgain = false;
            }
            while (playAgain);
        }

        private static void DisplayWelcome()
        {
            Console.ForegroundColor = ConsoleColor.Magenta;
            Console.WriteLine("\n\n\t______________________________________________________________________");
            Console.WriteLine("\t|   This is the Farmer Game. The object of this game is to get the   |");
            Console.WriteLine("\t|   farmer, fox, chicken and grain to the other side of the river.   |");
            Console.WriteLine("\t|  But, Not so fast!  If the farmer leaves the chicken & the grain   |");
            Console.WriteLine("\t| on either side of the river alone, the chicken will eat the grain! |");
            Console.WriteLine("\t| And that's just not good! If the farmer leaves the fox and chicken |");
            Console.WriteLine("\t|   on any side of the river alone, the fox will EAT the chicken!!   |");
            Console.WriteLine("\t|  Also, NOT good. In either case, you'll lose the game! IF you can  |");
            Console.WriteLine("\t|  get the farmer, the chicken, the fox AND the grain safely across  |");
            Console.WriteLine("\t|         the river all in one piece, you WIN!!! Good Luck!!         |");
            Console.WriteLine("\t----------------------------------------------------------------------\n\n");
            Console.ForegroundColor = ConsoleColor.White;
            Console.WriteLine("Press any key when you are ready to start!");
            Console.ReadKey();
        }

        public void DisplayGameState(Farmer theFarmer)
        {
            DisplayNorthBank();
            foreach (string item in theFarmer.NorthBank)
            {
                Console.Write(item + "  ");
            }
            DisplayRiver();
            foreach (string item in theFarmer.SouthBank)
            {
                Console.Write(item + "  ");
            }
            DisplaySouthBank();
            Console.WriteLine("\nThe farmer's on the " + theFarmer.TheFarmer + " bank of the river.");
        }

        private static void DisplayNorthBank()
        {
            Console.ForegroundColor = ConsoleColor.Black;
            Console.BackgroundColor = ConsoleColor.Green;
            Console.WriteLine("\n\n\n\n");
            Console.WriteLine("VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV");
            Console.WriteLine("VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV");
            Console.WriteLine("**************************** NORTH BANK **********************************");
            Console.WriteLine("VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV");
            Console.WriteLine("VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV");
            Console.ForegroundColor = ConsoleColor.White;
            Console.BackgroundColor = ConsoleColor.Black;
        }

        private static void DisplayRiver()
        {
            Console.ForegroundColor = ConsoleColor.White;
            Console.BackgroundColor = ConsoleColor.Blue;
            Console.WriteLine("\n");
            Console.WriteLine("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
            Console.WriteLine("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
            Console.WriteLine("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
            Console.WriteLine("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
            Console.ForegroundColor = ConsoleColor.White;
            Console.BackgroundColor = ConsoleColor.Black;
        }

        private static void DisplaySouthBank()
        {
            Console.ForegroundColor = ConsoleColor.Black;
            Console.BackgroundColor = ConsoleColor.Green;
            Console.WriteLine("\n");
            Console.WriteLine("VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV");
            Console.WriteLine("VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV");
            Console.WriteLine("**************************** SOUTH BANK **********************************");
            Console.WriteLine("VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV");
            Console.WriteLine("VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV");
            Console.ForegroundColor = ConsoleColor.White;
            Console.BackgroundColor = ConsoleColor.Black;
        }

        private static string PromptForMove()
        {
            string item;

            Console.Write("\n\nChoose next item for the farmer to cross with.\nIf you don't want to choose anything, just hit the enter key.\n");
            item = Console.ReadLine().ToUpper();
            Console.Clear();
            return item;
        }

        public void Play()
        {
            Farmer farmer = new Farmer();
            bool completed = false;

            while (!completed)
            {
                DisplayGameState(farmer);
                if (farmer.Move(PromptForMove()) != "ERROR")
                {
                    Console.WriteLine("\n\n");
                }
                else
                {
                    Console.WriteLine("\nThat item isn't there.. Please try again");
                }

                string eaten = farmer.AnimalAteFood();
                if (eaten == "ATECHICKEN")
                {
                    Console.WriteLine("\n\n\nGAH! The Fox ate the Chicken!!");
                    Console.WriteLine("Awe! Too Bad! You Lose!");
                    completed = true;
                }
                else if (eaten != "ATEGRAIN")
                {
                    completed = farmer.DetermineWin();
                    if (completed)
                    {
                        Console.WriteLine("You Win!! You're so smart!!\nCONGRATULATIONS!!");
                    }
                }
                else
                {
                    Console.WriteLine("\n\n\nEEPS!! The Chicken ate the Grain!!");
                    Console.WriteLine("Awe! Too Bad! You Lose!");
                    completed = true;
                }
            }
        }
    }
}

